[Setting category="Colors" name="Color name in plugins dropdown"]
bool colorDropdown = false;

[Setting category="Colors" name="Start outer color" color description="Start is usually not shown"]
vec4 StartOuterColor = vec4(1, 1, 0, 0.9);
[Setting category="Colors" name="Start inner color" color]
vec4 StartInnerColor = vec4(0, 1, 0, 0.9);
[Setting category="Colors" name="Start text color" color description="Shows order (linking group), if any"]
vec4 StartTextColor = vec4(1, 0, 1, 0.9);

[Setting category="Colors" name="Multilap outer color" color]
vec4 MultilapOuterColor = vec4(1, 1, 0, 0.9);
[Setting category="Colors" name="Multlap inner color" color]
vec4 MultilapInnerColor = vec4(1, 0, 0, 0.9);
[Setting category="Colors" name="Multilap text color" color description="Shows order (linking group), if any"]
vec4 MultilapTextColor = vec4(1, 0, 1, 0.9);

[Setting category="Colors" name="Finish outer color" color]
vec4 FinishOuterColor = vec4(1, 0, 0, 0.9);
[Setting category="Colors" name="Finish inner color" color]
vec4 FinishInnerColor = vec4(1, 1, 0, 0.9);
[Setting category="Colors" name="Finish text color" color description="Shows order (linking group), if any"]
vec4 FinishTextColor = vec4(1, 0, 1, 0.9);

[Setting category="Colors" name="Checkpoint outer color" color]
vec4 CheckpointOuterColor = vec4(0, 1, 0, 0.9);
[Setting category="Colors" name="Checkpoint inner color" color]
vec4 CheckpointInnerColor = vec4(0, 0, 1, 0.9);
[Setting category="Colors" name="Checkpoint text color" color description="Shows order (linking group), if any"]
vec4 CheckpointTextColor = vec4(1, 0, 1, 0.9);

[Setting category="Colors" name="Linked Checkpoint outer color" color]
vec4 LinkedCheckpointOuterColor = vec4(0, 0, 1, 0.9);
[Setting category="Colors" name="Linked Checkpoint inner color" color]
vec4 LinkedCheckpointInnerColor = vec4(0, 1, 0, 0.9);
[Setting category="Colors" name="Linked Checkpoint text color" color description="Shows order (linking group), if any"]
vec4 LinkedCheckpointTextColor = vec4(1, 0, 1, 0.9);

[Setting category="Colors" name="Other Checkpoint outer color" color description="If checkpoint isn't 'Checkpoint' or 'LinkedCheckpoint'. Idk why but mapper can do this"]
vec4 OtherCheckpointOuterColor = vec4(0, 1, 0, 0.9);
[Setting category="Colors" name="Other Checkpoint inner color" color]
vec4 OtherCheckpointInnerColor = vec4(1, 0, 0, 0.9);
[Setting category="Colors" name="Other Checkpoint text color" color description="Shows order (linking group), if any"]
vec4 OtherCheckpointTextColor = vec4(1, 0, 1, 0.9);
[Setting category="Colors" name="xdd"]
bool xddMode = false;

// text parameters
int font = nvg::LoadFont('DroidSans-Bold.ttf');

// xdd image
nvg::Texture@ xddTexture = nvg::LoadTexture("xdd.png");

string menuOptionColor(bool option) {
    if (option) {
        return "\\$afa";
    } else {
        return "\\$faa";
    }
}

void RenderMenu() {
    string menuColor;
    if (colorDropdown) {
        menuColor = Text::FormatOpenplanetColor(vec3(0.8, 0.8, 0.8) + 0.2 * CheckpointInnerColor.xyz);
    } else {
        menuColor = "\\$z";
    }
    if (UI::BeginMenu(Text::FormatOpenplanetColor(CheckpointOuterColor.xyz) + Icons::Circle + menuColor + " Unclaimed Checkpoint indicator")) {
        if (UI::MenuItem(menuOptionColor(show) + "Show ingame", "", show)) {
            show = !show;
        }
        if (UI::MenuItem(menuOptionColor(showEditor) + "Show in editor", "", showEditor)) {
            showEditor = !showEditor;
        }
        if (UI::MenuItem(menuOptionColor(run) + "Track checkpoints when hidden", "", run)) {
            run = !run;
        }
        if (UI::MenuItem(menuOptionColor(showDistance) + "Smaller dots with distance", "", showDistance)) {
            showDistance = !showDistance;
        }
        UI::Text("Dot size");
        UI::SameLine();
        UI::SetNextItemWidth(160);
        dotSize = UI::SliderInt("##Dot size", dotSize, 2, 64);
        if (inGame || inEditor) {
            if (UI::BeginMenu("Current map overrides")) {
                // if (!forceMapOptions) {

                if (UI::MenuItem(menuOptionColor(currentMapSettings&Options::Hide != 0) + "Hide dots", "", currentMapSettings&Options::Hide != 0)) {
                    currentMapSettings ^= Options::Hide;
                    if (currentMapSettings&Options::Hide == 0) {
                        show = true;
                        if (inEditor) {
                            showEditor = true;
                        }
                    }
                }
                if (UI::MenuItem(menuOptionColor(currentMapSettings&Options::Lowest != 0) + "Lowest linked CP", "", currentMapSettings&Options::Lowest != 0)) {
                    currentMapSettings ^= Options::Lowest;
                }
                if (UI::MenuItem(menuOptionColor(currentMapSettings&Options::xdd != 0) + "xdd", "", currentMapSettings&Options::xdd != 0)) {
                    currentMapSettings ^= Options::xdd;
                }
                if (UI::MenuItem(menuOptionColor(currentMapSettings&Options::Always != 0) + "Show taken CPs", "", currentMapSettings&Options::Always != 0)) {
                    currentMapSettings ^= Options::Always;
                }
                // }

                UI::EndMenu();
            }
        } else {
            UI::BeginDisabled();
            UI::MenuItem("Current map overrides");
            UI::EndDisabled();
        }
        if (UI::MenuItem(menuOptionColor(showUIHidden) + "Show when UI hidden", "", showUIHidden)) {
            showUIHidden = !showUIHidden;
        }
        // if (UI::MenuItem("Settings")) {
        //     UI::ShowNotification(Meta::ExecutingPlugin().Name, "Open the settings from the Openplanet settings menu", vec4(0.5f,0.5f,0.f,0.5f));
        // }
        UI::EndMenu();
    }
}

string debugtext = '';


void Render() {
    if (!((inMap || inEditor) && show && (showUIHidden || UI::IsGameUIVisible()))) {return;}
    CSmArenaClient@ playground = cast<CSmArenaClient>(GetApp().CurrentPlayground);
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);

    if(rootMap is null ||
        (!showEditor && (
        playground is null ||
        playground.Arena is null))) {
        reset();
        return;
        }

    if ((!showPause && IsPauseMenuOpen())) {
        return;
    }

    nvg::Reset();

    // Hide, except if individual Cps have 'Always'
    if (currentMapSettings&Options::Hide != 0) {
        for (uint i = 0; i < nottaken.Length; i++ ) {
            if (!isOption(nottaken[i].Order, Options::Always) || isOption(nottaken[i].Order, Options::Hide)) {continue;}
            CpData@ cp = nottaken[i];
            if (maptype == "TrackMania\\TM_Royal" && cp.Order != StartOrder && StartOrder != 0 && (cp.waypointType == WaypointType::Start || cp.waypointType == WaypointType::Finish)) {continue;}
            if (maptype == "FlagRushArena" && cp.Tag.StartsWith("BaseTeam") && Text::ParseUInt(cp.Tag.SubStr(-1)) != StartOrder) {continue;}

            renderCP(cp); // hides text if 'Always' (except if linked)
        }
        for (uint i = 0; i < cps.Length; i++ ) {
            CpData@ cp = cps[i];
            if ((isOption(cp.Order, Options::Always) && !isOption(cp.Order, Options::Hide) || (cp.waypointType == WaypointType::Start && cp.Order == 69)) && nottaken.Find(cp) < 0) {
                renderCP(cp);
            }
        }
    } else // Only show lowest unclaimed number
    if (currentMapSettings&Options::Lowest != 0) {
        if (currentMapSettings&Options::Always != 0) {
            for (uint i = 0; i < cps.Length; i++ ) {
                CpData@ cp = cps[i];
                if (isOption(cps[i].Order, Options::Always)) {
                    // will render, so skip next ifs
                } else if (cp.Tag == 'Goal' || cp.Tag == 'Multilap') {
                    if (!NextCPorders.IsEmpty()) {continue;}
                } else if (cp.Tag == 'Checkpoint' || cp.Tag == 'LinkedCheckpoint') {
                    if (cp.Order != 0 && !NextCPorders.IsEmpty() && cp.Order > NextCPorders[0]) {continue;}
                }
                renderCP(cp);
            }
        } else {
            for (uint i = 0; i < nottaken.Length; i++ ) {
                CpData@ cp = nottaken[i];
                // for (uint i = 0; i < NextCPorders.Length; i++) {print(NextCPorders[i]);}
                if (isOption(nottaken[i].Order, Options::Always)) {
                    // will render, so skip next ifs
                } else if (cp.Tag == 'Goal' || cp.Tag == 'Multilap') {
                    if (!NextCPorders.IsEmpty()) {continue;}
                } else if (cp.Tag == 'Checkpoint' || cp.Tag == 'LinkedCheckpoint') {
                    if (cp.Order != 0 && !NextCPorders.IsEmpty() && cp.Order != NextCPorders[0]) {continue;}
                }
                renderCP(cp);
            }
            for (uint i = 0; i < cps.Length; i++ ) {
                CpData@ cp = cps[i];
                if ((isOption(cp.Order, Options::Always) || (cp.waypointType == WaypointType::Start && cp.Order == 69)) && nottaken.Find(cp) < 0) {
                    renderCP(cp);
                }
            }
        }
    } else // always show all checkpoints
    if (currentMapSettings&Options::Always != 0) {
        for (uint i = 0; i < cps.Length; i++ ) {
            CpData@ cp = cps[i];
            if (isOption(cps[i].Order, Options::Hide) && !isOption(cps[i].Order, Options::Always)) {continue;}
            renderCP(cp);
        }
    } else // standard mode
    {
        for (uint i = 0; i < nottaken.Length; i++ ) {
            CpData@ cp = nottaken[i];
            if (maptype == "TrackMania\\TM_Royal" && StartOrder != 0 && cp.Order != StartOrder && (cp.waypointType == WaypointType::Start || cp.waypointType == WaypointType::Finish)) {continue;}
            if (maptype == "FlagRushArena" && cp.Tag.StartsWith("BaseTeam") && Text::ParseUInt(cp.Tag.SubStr(-1)) != StartOrder) {continue;}
            if (isOption(nottaken[i].Order, Options::Hide) && !isOption(nottaken[i].Order, Options::Always)) {continue;}

            renderCP(cp);
        }
        for (uint i = 0; i < cps.Length; i++ ) {
            CpData@ cp = cps[i];
            if ((isOption(cp.Order, Options::Always) || (cp.waypointType == WaypointType::Start && cp.Order == 69)) && nottaken.Find(cp) < 0) {
                renderCP(cp);
            }
        }
    }
    if (debugtext.Length > 0) {
        nvg::FontSize(20);
        nvg::FontFace(font);
        nvg::FillColor(vec4(1,0,1,1));
        nvg::Text(20, 40, debugtext);

        debugtext = '';
    }
}

bool renderCP(CpData@ cp) {
    if (Camera::IsBehind(cp.coords)) {return false;}

    vec3 pos = Camera::ToScreen(cp.coords);
    if (pos.z >= 0) {return false;} // only happens when loading map

    float size;
    if (showDistance) {
        float distance = Math::Sqrt(-pos.z/32);
        size = (2*dotSize*(distance+3))/(distance*4);
    } else {
        size = dotSize;
    }
    if (currentMapSettings&Options::xdd != 0 || isOption(cp.Order, Options::xdd)) {
    // if (false) {
        nvg::BeginPath();
        nvg::Rect(vec2(pos.x-size*1.5, pos.y-size*1.5), vec2(size*3, size*3));
        nvg::FillPaint(nvg::TexturePattern(vec2(pos.x-size*1.5, pos.y-size*1.5), vec2(size*3, size*3), 0., xddTexture, cp.outerColor.w));
        nvg::Fill();
        nvg::ClosePath();
    } else {
        nvg::BeginPath();
        nvg::Circle(pos.xy, size);
        nvg::FillColor(cp.outerColor);
        nvg::Fill();
        if (!lowDrawQuality) {
            nvg::BeginPath();
            nvg::Circle(pos.xy, (size*0.6));
            nvg::FillColor(cp.innerColor);
            nvg::Fill();
        }
    }
    if ((cp.Tag == 'LinkedCheckpoint' || !(isOption(cp.Order, Options::Lowest) || isOption(cp.Order, Options::xdd) || isOption(cp.Order, Options::Always)))) {
        if (cp.text.Length > 0) {
            nvg::FontSize(size*2);
            nvg::FontFace(font);
            nvg::FillColor(cp.textColor);
            vec2 textSize = nvg::TextBounds(cp.text);
            nvg::Text(pos.x-textSize.x/2,pos.y+textSize.y/2, cp.text);
        }
    }
    return true;
}


/* // nando removed settings menu Madge
bool IsSettingsMenuOpen() {
    MwFastBuffer<CHmsZoneOverlay@> Overlays = (GetApp().Viewport.Overlays);
    if (Overlays.Length > 10 && Overlays[10].SortOrder == 14) {
        return Overlays[10].m_CorpusVisibles.Length > 6;
    }// it seems to always be 10 when in a map. But idk if this is 100% consistent. But it does have order 14

    for (uint i = 0; i < Overlays.Length; i++) {
        if (Overlays[i].SortOrder == 14) {
            return Overlays[i].m_CorpusVisibles.Length > 6;
        }
    }
    return false;
}*/

bool IsPauseMenuOpen() {
    MwFastBuffer<CHmsZoneOverlay@> Overlays = (GetApp().Viewport.Overlays);
    if (Overlays.Length > 5 && Overlays[5].SortOrder == 4) {
        return (Overlays[5].m_CorpusVisibles.Length > 300 || (maptype != "TrackMania\\TM_Royal" && Overlays[5].m_CorpusVisibles.Length > 181));
    }// it seems to always be 5 when in a map. But idk if this is 100% consistent. But it does have order 4

    for (uint i = 0; i < Overlays.Length; i++) {
        if (Overlays[i].SortOrder == 4) {
            return (Overlays[i].m_CorpusVisibles.Length > 300 || (maptype != "TrackMania\\TM_Royal" && Overlays[i].m_CorpusVisibles.Length > 181));
        }
    }
    return false;
}